### This code reads one grid file and a table with (Vs, Vp/Vs) pairs in the first two colomuns. It interpolates the grids at the positions in the table and writes out the table with the interpolated values added as (one or more) new columns. A bicubic bspline interpolation is used.
### Usage example: python get_sio2_from_relationshp.py [grid file] [table file] 

############################################################################
import numpy as np
import sys
from scipy.interpolate import RectBivariateSpline
from scipy import interpolate

grid = sys.argv[1]
table = sys.argv[2]

data = np.loadtxt(grid)
data = data[np.lexsort((data[:,1],data[:,0]))] # strictly ascending Vs and VpVs
vs = data[:,0]
vpvs = data[:,1]
sio2 = data[:,2]

sorted_vs = np.unique(vs)
sorted_vpvs = np.unique(vpvs)
sorted_sio2 = np.reshape(sio2,(len(sorted_vs),len(sorted_vpvs)))

interpolation2d = RectBivariateSpline(sorted_vs, sorted_vpvs, sorted_sio2)

points = np.loadtxt(table)

for i in range(len(points)):
    print(points[i,0],points[i,1],float(interpolation2d(points[i,0],points[i,1])))
